<?php

/**
 * co_contratista actions.
 *
 * @package    contratacion
 * @subpackage co_contratista
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_contratistaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CO_CONTRATISTA', 'CO_NAT_JUR', 'CO_TIPO_IDEN'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_NAT_JUR' =>
        array(
            'id_nat_jur' => 'CO_CONTRATISTA'
        ),
        'CO_TIPO_IDEN' =>
        array(
            'id_tipo_iden' => 'CO_CONTRATISTA'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CO_CONTRATISTA' =>
        array(
            'id_contratista' => 'id_contratista',
            'id_nat_jur' => 'id_nat_jur',
            'id_tipo_iden' => 'id_tipo_iden',
            'num_doc' => 'num_doc',
            'dv' => 'dv',
            'nombre_razon' => 'nombre_razon',
            'telefono' => 'telefono',
            'celular' => 'celular',
            'direccion' => 'direccion',
            'email' => 'email',
            'representante_legal' => 'representante_legal',
            'ciudad' => 'ciudad',
            'num_doc,||, - ,||,nombre_razon' => 'completo',
            'factor_rh' => 'factor_rh',
            'fecha_nacimiento' => 'fecha_nacimiento',
            'ciudad_nacimiento' => 'ciudad_nacimiento',
            'id_tipo_regimen' => 'id_tipo_regimen',
            'num_doc_rep_leg' => 'num_doc_rep_leg'
        ),
        'CO_NAT_JUR' =>
        array(
            'descripcion' => 'naturaleza'
        ),
        'CO_TIPO_IDEN' =>
        array(
            'descripcion' => 'tipo_iden'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'num_doc'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CO_CONTRATISTA' =>
        array(
            'id_contratista,a' => array('!=' => array(-1)),
            'id_contratista,b' => array('=' => array('id_contratista')),
            'id_nat_jur' => array('=' => array('id_nat_jur')),
            'id_tipo_iden' => array('=' => array('id_tipo_iden')),
            'num_doc' => array('=' => array('num_doc')),
            'nombre_razon' => array('=' => array('nombre_razon')),
            'factor_rh' => array('=' => array('factor_rh')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'CO_CONTRATISTA' =>
        array(
            'num_doc' => array('LIKE' => array('input', '%')),
            'nombre_razon' => array('LIKEALLPLUS' => array('input', '%'))
    )); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//   protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_contratista'; //identificador de la tabla
    protected $id_names = array('id_contratista'); //llave primaria
    protected $field_names = array('id_nat_jur', 'id_tipo_iden', 'num_doc', 'dv',
        'nombre_razon', 'telefono', 'celular', 'direccion', 'email',
        'representante_legal', 'ciudad', 'factor_rh', 'fecha_nacimiento', 
        'ciudad_nacimiento','id_tipo_regimen','num_doc_rep_leg'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_CONTRATISTA'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_contratista'; //identificador unico de la tabla

    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
